/**********************************************************************
MPEG-4 Audio VM

This software module was originally developed by
  Y.B. Thomas Kim and S.H. Park (Samsung AIT)
and edited by
  Y.B. Thomas Kim (Samsung AIT) on 1997-08-25

in the course of development of the MPEG-2 NBC/MPEG-4 Audio standard
ISO/IEC 13818-7, 14496-1,2 and 3. This software module is an
implementation of a part of one or more MPEG-2 NBC/MPEG-4 Audio tools
as specified by the MPEG-2 NBC/MPEG-4 Audio standard. ISO/IEC gives
users of the MPEG-2 NBC/MPEG-4 Audio standards free license to this
software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-2 NBC/ MPEG-4 Audio
standards. Those intending to use this software module in hardware or
software products are advised that this use may infringe existing
patents. The original developer of this software module and his/her
company, the subsequent editors and their companies, and ISO/IEC have
no liability for use of this software module or modifications thereof
in an implementation. Copyright is not released for non MPEG-2
NBC/MPEG-4 Audio conforming products. The original developer retains
full right to use the code for his/her own purpose, assign or donate
the code to a third party and to inhibit third party from using the
code for non MPEG-2 NBC/MPEG-4 Audio conforming products. This
copyright notice must be included in all copies or derivative works.

Copyright (c) 1997.

**********************************************************************/

#ifndef _sam_sacle_h_
#define _sam_scale_h_

static int scale_findex_s[64]={
  20, 20, 20, 24, 24, 24, 28, 28,
  28, 32, 32, 32, 36, 36, 36, 40, 
  40, 40, 44, 44, 44, 48, 48, 48,
  52, 52, 52, 56, 56, 56, 60, 60,
  60, 64, 64, 64, 68, 68, 68, 72,
  72, 72, 76, 76, 76, 80, 80, 80,
  84, 84, 84,
};

static int scale_findex_l[64]={
  160, 168, 180, 192, 200, 212, 224, 232, 
  244, 256, 264, 276, 288, 296, 308, 320, 
  328, 340, 352, 360, 372, 384, 392, 404, 
  416, 424, 436, 448, 456, 468, 480, 488, 
  500, 512, 520, 532, 544, 552, 564, 576, 
  584, 596, 608, 616, 628, 640, 648, 660, 
  672,
};

static int scale_qbw[64]={
  22, 23, 24, 24, 25, 25, 26, 26,
  27, 27, 27, 28, 28, 29, 29, 29,
  30, 30, 30, 31, 31, 31, 32, 32,
  32, 33, 33, 33, 34, 34, 34, 35,
  35, 35, 36, 36, 36, 37, 37, 37,
  38, 38, 38, 39, 39, 39, 40, 40,
  40,
};

static int scale_qbws[64]={
   5,  5,  5,  6,  6,  6,  6,  6,
   6,  7,  7,  7,  7,  7,  7,  8,
   8,  8,  8,  8,  8,  9,  9,  9,
   9,  9,  9,  9,  9,  9, 10, 10,
  10, 10, 10, 10, 10, 10, 10, 11,
  11, 11, 11, 11, 11, 11, 12, 12,
  12,
};

static int scale_bits[64]={
   341, 362, 384, 405, 426, 448, 469, 490,
   512, 533, 554, 576, 597, 618, 640, 661,
   682, 704, 725, 746, 768, 789, 810, 832,
   853, 874, 896, 917, 938, 960, 981,1002,
  1024,1045,1066,1088,1109,1130,1152,1173,
  1194,1216,1237,1258,1280,1301,1322,1344,
  1365
};

#endif /* #ifndef _sam_sacle_h_ */
